import React, {useState, useEffect, useRef} from 'react';
import List from '@mui/material/List';
import ListItem from '@mui/material/ListItem';
import ListItemText from '@mui/material/ListItemText';
import ListItemAvatar from '@mui/material/ListItemAvatar';
import Box from '@mui/material/Box';

import {Link} from 'react-router-dom'

import { FloatBtn, ChatAvatar } from "../components"
import { connect }  from 'react-redux'


const Chat = ({chat}) => {

  const {_id, title, owner, members} = chat

  return (
    <Link style={{textDecoration: 'none', color: "#1976d2"}} to={`/main/${_id}`}>
      <ListItem >
        <ListItemAvatar>
          <ChatAvatar chat={chat} />
        </ListItemAvatar>
        <ListItemText primary={title} secondary={'затычка'} />
      </ListItem>
    </Link>
  )
}

const ChatList = ({ chats=[] }) => {

  return (
      <List        
        sx={{ width: '100%', bgcolor: 'background.paper', position: 'relative', zIndex: 2, }}
        >
        <Box sx={{  position: 'fixed', top: '90%', left: '25%', zIndex: 10}} >
          <FloatBtn />
        </Box>
        {chats.map(chat => <Chat key={chat._id} chat={chat}/>)}  
      
      </List>
  )
}
export const CChatList = connect( state => ({ chats: Object.values(state.chats) }))(ChatList)


