import React, {useState, useEffect, useRef} from 'react';

import { connect }  from 'react-redux'
import {
  actionFullChatList
} from "../actions"

import { CChatList } from '../components'

const chatsPage= {
   height: "calc(100vh - 60px)",
   overflowY: "auto"
 }

const ChatsPage = ({auth, getChats, chatsCount=50}) => {
   const [chatBlock, setChatBlock] = useState(0)
 
   useEffect(() => {
     const userId = auth.payload?.sub?.id 
     if (userId) {
       getChats(userId, chatBlock, chatsCount)
     } 
   },[chatBlock])
 
   return (
     <div 
       style={chatsPage}
       onScroll={(e) => {
          if (e.target.scrollTop >= e.target.scrollHeight - e.target.clientHeight) {
            setChatBlock(chatBlock => chatBlock + chatsCount)
          }
       }}
       >

         <CChatList />

     </div>
   )
 }
 export const CChatsPage= connect( state => ({ auth: state.auth }),
                                         {getChats: actionFullChatList})(ChatsPage)