import React, {useState, useEffect} from 'react';

import {
   Header, 
   CMsgList,
   CSendingField,   
} from "../components"

import {
   actionFullMsgsByChat
 } from "../actions"
 import { connect } from 'react-redux'



const msgPageContainer = {
   backgroundColor: '#eee',
   height: "100vh",
   width: "100%"
}
const msgPageHeader = {
   height: "60px"
}
const msgPageBody = {
   height: "calc(100vh - 60px)",
   display: "flex",
   flexDirection: "column",
   justifyContent: "space-between"
}

const msgs = {
   flexGrow: 1,
   overflowY: "auto",
}
const msgSend = {
   flexGrow: 0,
   height: "max-content",
   maxHeight: "60%",
}

const MsgPage = ({ match:{params:{_id}}, getData }) => {

   useEffect(() => {
      getData(_id, 0, 50)
   },[_id])

   return (
      <>  
         <div style={msgPageContainer}>

            <div style={msgPageHeader}>
               <Header> 
                  <div>
                     шапка2: инфо о чате и управление, управление сообщениями
                  </div>
               </Header>  
            </div>

            <div style={msgPageBody}>

               <div style={msgs}>
                  <CMsgList key={_id} chatId={_id} />
               </div>

               <div style={msgSend}>
                  <CSendingField key={_id} chatId={_id} />
               </div>       

            </div>

         </div>              
      </>
   )
}
export const CMsgPage = connect( null, {getData: actionFullMsgsByChat})(MsgPage)