
// const chats = {
//   chats: [ 
//     {_id: '333', title: 'moiChat2', avatar: null, lastModified: 'segodnya', owner: {login: 'ya'}, members:[]},
//     {_id: '222', title: 'moiChat', avatar: null, lastModified: 'vchera', owner: {login: 'ya'}, members:[]}
//   ],
//   messages: {
//     '222': [
//       {text: 'uuu'}, {text: 'uuuuuu'}
//     ],
//     '333': [
//       {text: 'UUU'}, {text: 'U'}
//     ]
//   }
// }

// payload - или массив чатов или массив сообщений или 1 чат
 export function chatsReducer (state={}, {type, payload}) {
    if (!state) {
        return {}
    }

    const types = {

      CHATS() {
        if (payload && payload.length > 0) {

          const newChats = {...state}     
          for (const chat of payload) {
            newChats[chat._id] = chat
          }

          const newState = Object.fromEntries(
            Object.entries(newChats).sort((a, b) => {
              if (a[1].lastModified > b[1].lastModified) {
                return -1
              }
              if (a[1].lastModified < b[1].lastModified) {
                return 1
              }
              return 0
            })
          )

          return newState
        }
        return state
      },

      CHAT_LEFT() {   
        const { [payload._id]: removed, ...newState }  = state        
        return newState
      },

      MSGS() {
        if (payload && payload.length > 0) {
        
          const chatId = payload[0]?.chat?._id

          const msgState = state[chatId]?.messages || []
          
          for (const newMsg of payload || []) {   
              const currIndex = msgState.findIndex(oldMsg => oldMsg._id === newMsg._id)

              if (currIndex === -1) {
                msgState.push(newMsg)                
              } else {
                msgState[currIndex] = newMsg
              }
          }

          const newMsgState = msgState.sort((a, b) => {
            if (a._id > b._id) {
              return -1
            }
            if (a._id < b._id) {
              return 1
            }
            return 0
          })

          const newState = {
            ...state,
            [chatId]: {
              ...state[chatId],
              messages: newMsgState
            }
          }
          return newState
        }
        return state
      }

    }
    if (type in types) {        
        return types[type]()
    }
    return state
 }

  export const actionChatList = (chats) => (
        {type: 'CHATS', payload: chats}
  )     
  export const actionChatOne = (chat) => (
        {type: 'CHATS', payload: [chat]}
  )
  export const actionChatLeft = (chat) => (
        {type: 'CHAT_LEFT', payload: chat}
  )

  export const actionMsgList = (msgs) => (
        {type: 'MSGS', payload: msgs}
  )
  export const actionMsgOne = (msg) => (
        {type: 'MSGS', payload: [msg]}
  )
      










